﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace H2V_Script_Maker
{
    public partial class Editor : UserControl
    {
        public Editor()
        {
            InitializeComponent();
            richTextBox1.VScroll +=new EventHandler(richTextBox1_VScroll);
            richTextBox1.TextChanged +=new EventHandler(richTextBox1_TextChanged);
            richTextBox1.SizeChanged +=new EventHandler(richTextBox1_SizeChanged);
            richTextBox1.FontChanged +=new EventHandler(richTextBox1_FontChanged);
            label1.Font = new Font(richTextBox1.Font.FontFamily,
                          richTextBox1.Font.Size);
        }
        public void richTextBox1_FontChanged(object sender, EventArgs e)
        {
            int d = richTextBox1.GetPositionFromCharIndex(0).Y %(richTextBox1.Font.Height + 1);
            label1.Location = new Point(0, d);

            updatelabel1();
        }
        public void richTextBox1_SizeChanged(object sender, EventArgs e)
        {
            int d = richTextBox1.GetPositionFromCharIndex(0).Y %(richTextBox1.Font.Height + 1);
            label1.Location = new Point(0, d);

            updatelabel1();
        }
        public void richTextBox1_VScroll(object sender, EventArgs e)
        {
            int d = richTextBox1.GetPositionFromCharIndex(0).Y % (richTextBox1.Font.Height + 1);
            label1.Location = new Point(0, d);

            updatelabel1();
        }
        public void richTextBox1_TextChanged(object sender, EventArgs e)
        {
            int d = richTextBox1.GetPositionFromCharIndex(0).Y % (richTextBox1.Font.Height + 1);
            label1.Location = new Point(0, d);

            updatelabel1();
        }
        private void updatelabel1()
        {
            Point pos = new Point(0, 0);
            int firstIndex = richTextBox1.GetCharIndexFromPosition(pos);
            int firstLine = richTextBox1.GetLineFromCharIndex(firstIndex);
            pos.X = ClientRectangle.Width;
            pos.Y = ClientRectangle.Height;
            int lastIndex = richTextBox1.GetCharIndexFromPosition(pos);
            int lastLine = richTextBox1.GetLineFromCharIndex(lastIndex);
            pos = richTextBox1.GetPositionFromCharIndex(lastIndex);
            label1.Text = "";
            for (int i = firstLine; i <= lastLine + 1; i++)
            {
                label1.Text += i +1 + "\n";
            }
        }

        private void Editor_Load(object sender, EventArgs e)
        {
            updatelabel1();
        }
    }
}
