﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
namespace H2V_Script_Maker
{
    public struct Script
    {
        public int Bytesize;
        public string[] Scripta;
        public bool Comments;
        public string Name;
    }
    class H2Script
    {
        public Script Open()
        {
            System.Windows.Forms.OpenFileDialog dialog = new System.Windows.Forms.OpenFileDialog();
            dialog.Filter = "HSC Script *.scenario_hs_source_file|*.scenario_hs_source_file";
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                FileStream FS = new FileStream(dialog.FileName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite);
                BinaryReader Br = new BinaryReader(FS);
                Br.BaseStream.Position = 0x50;
                Script S = new Script();
                foreach (char c in Br.ReadChars(31))
                {
                    if (c != '\0' || c.ToString() != "")
                    {
                        S.Name += c;
                    }
                }
                Br.BaseStream.Position = 0x70;
                S.Bytesize = Br.ReadInt32();
                Br.BaseStream.Position = 0x84;
                S.Scripta = new string[1];
                foreach (char c in Br.ReadChars(S.Bytesize))
                {
                    S.Scripta[0] += c;
                }
                return S;
            }
            return new Script();
        }
        public void save(Script S)
        {
            System.Windows.Forms.FolderBrowserDialog dialog = new System.Windows.Forms.FolderBrowserDialog();
            dialog.Description = "Select Folder to save in";
            dialog.ShowNewFolderButton = true;
            if (dialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                FileStream FS = new FileStream(dialog.SelectedPath +@"/"+ S.Name + ".scenario_hs_source_file", FileMode.OpenOrCreate);
                BinaryWriter Br = new BinaryWriter(FS);
                Br.BaseStream.Position = 0;
                Br.Write(new byte[24]{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0});
                Br.BaseStream.Position = 0x24;
                Br.Write(new byte[4] {0x2A, 0x63, 0x73, 0x68});
                Br.BaseStream.Position = 0x28;
                Random R = new Random();
                Br.Write(new byte[4] { (byte)R.Next(0, 255), (byte)R.Next(0, 255), (byte)R.Next(0, 255), 0x40 });
                Br.BaseStream.Position = 0x38;
                Br.Write(0x01);
                Br.BaseStream.Position = 0x3B;
                Br.Write(new byte[9] { 0xFF, 0x21, 0x4D, 0x4C, 0x42, 0x64, 0x66, 0x62, 0x74 });
                Br.BaseStream.Position = 0x48;
                Br.Write(0x01);
                Br.BaseStream.Position = 0x4C;
                Br.Write(0x34);
                Br.BaseStream.Position = 0x4F;
                Br.Write(S.Name);
                Br.BaseStream.Position = 0x4E;
                Br.Write(new byte[2] { 0x00, 0x00 });
                if (S.Comments)
                {
                    Br.BaseStream.Position = 0x78;
                    Br.Write(0x44);
                }
                Br.BaseStream.Position = 0x84;
                int bytes = 0;
                foreach (string s in S.Scripta)
                {
                    foreach (char c in s)
                    {
                        Br.Write(BitConverter.GetBytes(c)[0]);
                    }
                    bytes += s.ToCharArray().Length;
                    if (S.Scripta.ToList().IndexOf(s) != S.Scripta.Length - 1)
                    {
                        Br.Write(new byte[2] { 0x0D, 0x0A });
                        bytes += 2;
                    }
                    else if (S.Scripta.ToList().IndexOf(s) == S.Scripta.Length - 1)
                    {
                        Br.Write(new byte[3] { 0x0D, 0x0A, 0x00 });
                        bytes += 3;
                    }
                }
                Br.BaseStream.Position = 0x70;
                Br.Write(bytes);
                Br.BaseStream.Position = 0x7C;
                Br.Write(new byte[8] { 0x70, 0x15, 0x89, 0x0B, 0x04, 0x21, 0x92, 0x00});
                Br.Flush();
                FS.Flush();
                FS.Close();
                FS.Dispose();
            }
        }
    }
}
